#include <Rcpp.h>
using namespace Rcpp;

//[[Rcpp::export]]
NumericMatrix inv_chol(NumericMatrix A){
  int n = A.nrow();
  double nr = A(0, 0);
  if(nr != 1){
    A = A / nr;
  }
  NumericVector av = A.row(0);
  NumericVector r = tail(av, n - 1);
  NumericVector y(n);
  NumericMatrix R(n, n);
  R.fill_diag(1);
  // initial values:
  y(0) = -r(0);
  double a = -r(0);
  double b = 1;
  // updating b:
  b = (1 - pow(a, 2)) * b;
  R(0, 1) = y(0);
  R.column(1) = R.column(1) / pow(b, 0.5);
  // updating other columns:
  // int k = 0;
  for(int k = 0; k <= (n-3); k++){
    NumericVector rsub = head(r, k+1);
    NumericVector rrev = rev(rsub);
    NumericVector ysub = head(y, k+1);
    NumericVector yrev = rev(ysub);
    // Updating a:
    a = -(r(k+1) + sum(rrev * ysub))/b;
    // Updating y:
    NumericVector sum_y = ysub + a * yrev;
    for(int j = 0; j < k+1; j ++){
      y(j) = sum_y(j); 
    }
    y(k+1) = a;
    // Updating b:
    b = (1 - pow(a, 2)) * b;
    // Updating the columns:
    NumericVector ysub2 = head(y, k+2);
    NumericVector yrev2 = rev(ysub2);
    for(int j = 0; j < k+2; j++){
      R(j, k+2) = yrev2(j);
    }
    R.column(k+2) = R.column(k+2) / pow(b, 0.5); 
  }
  R = R / pow(nr, 0.5);
  return R;
}



